--------------------------------------------------------------------------------
-- Copyright (c) 1995-2007 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version: J.38
--  \   \         Application: netgen
--  /   /         Filename: bram_512_32.vhd
-- /___/   /\     Timestamp: Wed Sep 05 14:11:16 2007
-- \   \  /  \ 
--  \___\/\___\
--             
-- Command	: -intstyle ise -w -sim -ofmt vhdl C:\User\Daniel\Protel\Converter\FPGAUplinkSA\coregen\tmp\_cg\bram_512_32.ngc C:\User\Daniel\Protel\Converter\FPGAUplinkSA\coregen\tmp\_cg\bram_512_32.vhd 
-- Device	: 4vfx60ff672-10
-- Input file	: C:/User/Daniel/Protel/Converter/FPGAUplinkSA/coregen/tmp/_cg/bram_512_32.ngc
-- Output file	: C:/User/Daniel/Protel/Converter/FPGAUplinkSA/coregen/tmp/_cg/bram_512_32.vhd
-- # of Entities	: 1
-- Design Name	: bram_512_32
-- Xilinx	: C:\Program Files\Xilinx92i
--             
-- Purpose:    
--     This VHDL netlist is a verification model and uses simulation 
--     primitives which may not represent the true implementation of the 
--     device, however the netlist is functionally correct and should not 
--     be modified. This file cannot be synthesized and should only be used 
--     with supported simulation tools.
--             
-- Reference:  
--     Development System Reference Guide, Chapter 23
--     Synthesis and Simulation Design Guide, Chapter 6
--             
--------------------------------------------------------------------------------


-- synopsys translate_off
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;
use UNISIM.VPKG.ALL;

entity bram_512_32 is
  port (
    ena : in STD_LOGIC := 'X'; 
    enb : in STD_LOGIC := 'X'; 
    clka : in STD_LOGIC := 'X'; 
    clkb : in STD_LOGIC := 'X'; 
    wea : in STD_LOGIC_VECTOR ( 3 downto 0 ); 
    web : in STD_LOGIC_VECTOR ( 3 downto 0 ); 
    addra : in STD_LOGIC_VECTOR ( 8 downto 0 ); 
    addrb : in STD_LOGIC_VECTOR ( 8 downto 0 ); 
    douta : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    doutb : out STD_LOGIC_VECTOR ( 31 downto 0 ); 
    dina : in STD_LOGIC_VECTOR ( 31 downto 0 ); 
    dinb : in STD_LOGIC_VECTOR ( 31 downto 0 ) 
  );
end bram_512_32;

architecture STRUCTURE of bram_512_32 is
  signal BU2_N2 : STD_LOGIC; 
  signal BU2_N0 : STD_LOGIC; 
  signal NLW_VCC_P_UNCONNECTED : STD_LOGIC; 
  signal NLW_GND_G_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_CASCADEOUTA_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_CASCADEOUTB_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_0_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_3_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_2_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_1_UNCONNECTED : STD_LOGIC; 
  signal NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_0_UNCONNECTED : STD_LOGIC; 
  signal dina_2 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal addra_3 : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal wea_4 : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal douta_5 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal dinb_6 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
  signal addrb_7 : STD_LOGIC_VECTOR ( 8 downto 0 ); 
  signal web_8 : STD_LOGIC_VECTOR ( 3 downto 0 ); 
  signal doutb_9 : STD_LOGIC_VECTOR ( 31 downto 0 ); 
begin
  wea_4(3) <= wea(3);
  wea_4(2) <= wea(2);
  wea_4(1) <= wea(1);
  wea_4(0) <= wea(0);
  web_8(3) <= web(3);
  web_8(2) <= web(2);
  web_8(1) <= web(1);
  web_8(0) <= web(0);
  addra_3(8) <= addra(8);
  addra_3(7) <= addra(7);
  addra_3(6) <= addra(6);
  addra_3(5) <= addra(5);
  addra_3(4) <= addra(4);
  addra_3(3) <= addra(3);
  addra_3(2) <= addra(2);
  addra_3(1) <= addra(1);
  addra_3(0) <= addra(0);
  addrb_7(8) <= addrb(8);
  addrb_7(7) <= addrb(7);
  addrb_7(6) <= addrb(6);
  addrb_7(5) <= addrb(5);
  addrb_7(4) <= addrb(4);
  addrb_7(3) <= addrb(3);
  addrb_7(2) <= addrb(2);
  addrb_7(1) <= addrb(1);
  addrb_7(0) <= addrb(0);
  douta(31) <= douta_5(31);
  douta(30) <= douta_5(30);
  douta(29) <= douta_5(29);
  douta(28) <= douta_5(28);
  douta(27) <= douta_5(27);
  douta(26) <= douta_5(26);
  douta(25) <= douta_5(25);
  douta(24) <= douta_5(24);
  douta(23) <= douta_5(23);
  douta(22) <= douta_5(22);
  douta(21) <= douta_5(21);
  douta(20) <= douta_5(20);
  douta(19) <= douta_5(19);
  douta(18) <= douta_5(18);
  douta(17) <= douta_5(17);
  douta(16) <= douta_5(16);
  douta(15) <= douta_5(15);
  douta(14) <= douta_5(14);
  douta(13) <= douta_5(13);
  douta(12) <= douta_5(12);
  douta(11) <= douta_5(11);
  douta(10) <= douta_5(10);
  douta(9) <= douta_5(9);
  douta(8) <= douta_5(8);
  douta(7) <= douta_5(7);
  douta(6) <= douta_5(6);
  douta(5) <= douta_5(5);
  douta(4) <= douta_5(4);
  douta(3) <= douta_5(3);
  douta(2) <= douta_5(2);
  douta(1) <= douta_5(1);
  douta(0) <= douta_5(0);
  doutb(31) <= doutb_9(31);
  doutb(30) <= doutb_9(30);
  doutb(29) <= doutb_9(29);
  doutb(28) <= doutb_9(28);
  doutb(27) <= doutb_9(27);
  doutb(26) <= doutb_9(26);
  doutb(25) <= doutb_9(25);
  doutb(24) <= doutb_9(24);
  doutb(23) <= doutb_9(23);
  doutb(22) <= doutb_9(22);
  doutb(21) <= doutb_9(21);
  doutb(20) <= doutb_9(20);
  doutb(19) <= doutb_9(19);
  doutb(18) <= doutb_9(18);
  doutb(17) <= doutb_9(17);
  doutb(16) <= doutb_9(16);
  doutb(15) <= doutb_9(15);
  doutb(14) <= doutb_9(14);
  doutb(13) <= doutb_9(13);
  doutb(12) <= doutb_9(12);
  doutb(11) <= doutb_9(11);
  doutb(10) <= doutb_9(10);
  doutb(9) <= doutb_9(9);
  doutb(8) <= doutb_9(8);
  doutb(7) <= doutb_9(7);
  doutb(6) <= doutb_9(6);
  doutb(5) <= doutb_9(5);
  doutb(4) <= doutb_9(4);
  doutb(3) <= doutb_9(3);
  doutb(2) <= doutb_9(2);
  doutb(1) <= doutb_9(1);
  doutb(0) <= doutb_9(0);
  dina_2(31) <= dina(31);
  dina_2(30) <= dina(30);
  dina_2(29) <= dina(29);
  dina_2(28) <= dina(28);
  dina_2(27) <= dina(27);
  dina_2(26) <= dina(26);
  dina_2(25) <= dina(25);
  dina_2(24) <= dina(24);
  dina_2(23) <= dina(23);
  dina_2(22) <= dina(22);
  dina_2(21) <= dina(21);
  dina_2(20) <= dina(20);
  dina_2(19) <= dina(19);
  dina_2(18) <= dina(18);
  dina_2(17) <= dina(17);
  dina_2(16) <= dina(16);
  dina_2(15) <= dina(15);
  dina_2(14) <= dina(14);
  dina_2(13) <= dina(13);
  dina_2(12) <= dina(12);
  dina_2(11) <= dina(11);
  dina_2(10) <= dina(10);
  dina_2(9) <= dina(9);
  dina_2(8) <= dina(8);
  dina_2(7) <= dina(7);
  dina_2(6) <= dina(6);
  dina_2(5) <= dina(5);
  dina_2(4) <= dina(4);
  dina_2(3) <= dina(3);
  dina_2(2) <= dina(2);
  dina_2(1) <= dina(1);
  dina_2(0) <= dina(0);
  dinb_6(31) <= dinb(31);
  dinb_6(30) <= dinb(30);
  dinb_6(29) <= dinb(29);
  dinb_6(28) <= dinb(28);
  dinb_6(27) <= dinb(27);
  dinb_6(26) <= dinb(26);
  dinb_6(25) <= dinb(25);
  dinb_6(24) <= dinb(24);
  dinb_6(23) <= dinb(23);
  dinb_6(22) <= dinb(22);
  dinb_6(21) <= dinb(21);
  dinb_6(20) <= dinb(20);
  dinb_6(19) <= dinb(19);
  dinb_6(18) <= dinb(18);
  dinb_6(17) <= dinb(17);
  dinb_6(16) <= dinb(16);
  dinb_6(15) <= dinb(15);
  dinb_6(14) <= dinb(14);
  dinb_6(13) <= dinb(13);
  dinb_6(12) <= dinb(12);
  dinb_6(11) <= dinb(11);
  dinb_6(10) <= dinb(10);
  dinb_6(9) <= dinb(9);
  dinb_6(8) <= dinb(8);
  dinb_6(7) <= dinb(7);
  dinb_6(6) <= dinb(6);
  dinb_6(5) <= dinb(5);
  dinb_6(4) <= dinb(4);
  dinb_6(3) <= dinb(3);
  dinb_6(2) <= dinb(2);
  dinb_6(1) <= dinb(1);
  dinb_6(0) <= dinb(0);
  VCC_0 : VCC
    port map (
      P => NLW_VCC_P_UNCONNECTED
    );
  GND_1 : GND
    port map (
      G => NLW_GND_G_UNCONNECTED
    );
  BU2_XST_VCC : VCC
    port map (
      P => BU2_N2
    );
  BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP : RAMB16
    generic map(
      DOA_REG => 0,
      DOB_REG => 0,
      SRVAL_A => X"000000000",
      INIT_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_08 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_09 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_0F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_10 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_11 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_12 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_13 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_14 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_15 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_16 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_17 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_18 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_19 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_1F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_20 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_21 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_22 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_23 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_24 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_25 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_26 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_27 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_28 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_29 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_2F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_30 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_31 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_32 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_33 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_34 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_35 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_36 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_37 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_38 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_39 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3A => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3B => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3C => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3D => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3E => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_3F => X"0000000000000000000000000000000000000000000000000000000000000000",
      INIT_FILE => "NONE",
      INIT_A => X"000000000",
      INIT_B => X"000000000",
      INITP_00 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_01 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_02 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_03 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_04 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_05 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INVERT_CLK_DOA_REG => FALSE,
      INVERT_CLK_DOB_REG => FALSE,
      RAM_EXTENSION_A => "NONE",
      RAM_EXTENSION_B => "NONE",
      READ_WIDTH_A => 36,
      READ_WIDTH_B => 36,
      SIM_COLLISION_CHECK => "ALL",
      INITP_06 => X"0000000000000000000000000000000000000000000000000000000000000000",
      INITP_07 => X"0000000000000000000000000000000000000000000000000000000000000000",
      WRITE_MODE_A => "WRITE_FIRST",
      WRITE_MODE_B => "WRITE_FIRST",
      WRITE_WIDTH_A => 36,
      WRITE_WIDTH_B => 36,
      SRVAL_B => X"000000000"
    )
    port map (
      CASCADEINA => BU2_N0,
      CASCADEINB => BU2_N0,
      CLKA => clka,
      CLKB => clkb,
      ENA => ena,
      REGCEA => BU2_N0,
      REGCEB => BU2_N0,
      ENB => enb,
      SSRA => BU2_N0,
      SSRB => BU2_N0,
      CASCADEOUTA => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_CASCADEOUTA_UNCONNECTED,
      CASCADEOUTB => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_CASCADEOUTB_UNCONNECTED,
      ADDRA(14) => BU2_N0,
      ADDRA(13) => addra_3(8),
      ADDRA(12) => addra_3(7),
      ADDRA(11) => addra_3(6),
      ADDRA(10) => addra_3(5),
      ADDRA(9) => addra_3(4),
      ADDRA(8) => addra_3(3),
      ADDRA(7) => addra_3(2),
      ADDRA(6) => addra_3(1),
      ADDRA(5) => addra_3(0),
      ADDRA(4) => BU2_N0,
      ADDRA(3) => BU2_N0,
      ADDRA(2) => BU2_N0,
      ADDRA(1) => BU2_N0,
      ADDRA(0) => BU2_N0,
      ADDRB(14) => BU2_N0,
      ADDRB(13) => addrb_7(8),
      ADDRB(12) => addrb_7(7),
      ADDRB(11) => addrb_7(6),
      ADDRB(10) => addrb_7(5),
      ADDRB(9) => addrb_7(4),
      ADDRB(8) => addrb_7(3),
      ADDRB(7) => addrb_7(2),
      ADDRB(6) => addrb_7(1),
      ADDRB(5) => addrb_7(0),
      ADDRB(4) => BU2_N0,
      ADDRB(3) => BU2_N0,
      ADDRB(2) => BU2_N0,
      ADDRB(1) => BU2_N0,
      ADDRB(0) => BU2_N0,
      DIA(31) => dina_2(31),
      DIA(30) => dina_2(30),
      DIA(29) => dina_2(29),
      DIA(28) => dina_2(28),
      DIA(27) => dina_2(27),
      DIA(26) => dina_2(26),
      DIA(25) => dina_2(25),
      DIA(24) => dina_2(24),
      DIA(23) => dina_2(23),
      DIA(22) => dina_2(22),
      DIA(21) => dina_2(21),
      DIA(20) => dina_2(20),
      DIA(19) => dina_2(19),
      DIA(18) => dina_2(18),
      DIA(17) => dina_2(17),
      DIA(16) => dina_2(16),
      DIA(15) => dina_2(15),
      DIA(14) => dina_2(14),
      DIA(13) => dina_2(13),
      DIA(12) => dina_2(12),
      DIA(11) => dina_2(11),
      DIA(10) => dina_2(10),
      DIA(9) => dina_2(9),
      DIA(8) => dina_2(8),
      DIA(7) => dina_2(7),
      DIA(6) => dina_2(6),
      DIA(5) => dina_2(5),
      DIA(4) => dina_2(4),
      DIA(3) => dina_2(3),
      DIA(2) => dina_2(2),
      DIA(1) => dina_2(1),
      DIA(0) => dina_2(0),
      DIB(31) => dinb_6(31),
      DIB(30) => dinb_6(30),
      DIB(29) => dinb_6(29),
      DIB(28) => dinb_6(28),
      DIB(27) => dinb_6(27),
      DIB(26) => dinb_6(26),
      DIB(25) => dinb_6(25),
      DIB(24) => dinb_6(24),
      DIB(23) => dinb_6(23),
      DIB(22) => dinb_6(22),
      DIB(21) => dinb_6(21),
      DIB(20) => dinb_6(20),
      DIB(19) => dinb_6(19),
      DIB(18) => dinb_6(18),
      DIB(17) => dinb_6(17),
      DIB(16) => dinb_6(16),
      DIB(15) => dinb_6(15),
      DIB(14) => dinb_6(14),
      DIB(13) => dinb_6(13),
      DIB(12) => dinb_6(12),
      DIB(11) => dinb_6(11),
      DIB(10) => dinb_6(10),
      DIB(9) => dinb_6(9),
      DIB(8) => dinb_6(8),
      DIB(7) => dinb_6(7),
      DIB(6) => dinb_6(6),
      DIB(5) => dinb_6(5),
      DIB(4) => dinb_6(4),
      DIB(3) => dinb_6(3),
      DIB(2) => dinb_6(2),
      DIB(1) => dinb_6(1),
      DIB(0) => dinb_6(0),
      DIPA(3) => BU2_N0,
      DIPA(2) => BU2_N0,
      DIPA(1) => BU2_N0,
      DIPA(0) => BU2_N0,
      DIPB(3) => BU2_N0,
      DIPB(2) => BU2_N0,
      DIPB(1) => BU2_N0,
      DIPB(0) => BU2_N0,
      WEA(3) => wea_4(3),
      WEA(2) => wea_4(2),
      WEA(1) => wea_4(1),
      WEA(0) => wea_4(0),
      WEB(3) => web_8(3),
      WEB(2) => web_8(2),
      WEB(1) => web_8(1),
      WEB(0) => web_8(0),
      DOA(31) => douta_5(31),
      DOA(30) => douta_5(30),
      DOA(29) => douta_5(29),
      DOA(28) => douta_5(28),
      DOA(27) => douta_5(27),
      DOA(26) => douta_5(26),
      DOA(25) => douta_5(25),
      DOA(24) => douta_5(24),
      DOA(23) => douta_5(23),
      DOA(22) => douta_5(22),
      DOA(21) => douta_5(21),
      DOA(20) => douta_5(20),
      DOA(19) => douta_5(19),
      DOA(18) => douta_5(18),
      DOA(17) => douta_5(17),
      DOA(16) => douta_5(16),
      DOA(15) => douta_5(15),
      DOA(14) => douta_5(14),
      DOA(13) => douta_5(13),
      DOA(12) => douta_5(12),
      DOA(11) => douta_5(11),
      DOA(10) => douta_5(10),
      DOA(9) => douta_5(9),
      DOA(8) => douta_5(8),
      DOA(7) => douta_5(7),
      DOA(6) => douta_5(6),
      DOA(5) => douta_5(5),
      DOA(4) => douta_5(4),
      DOA(3) => douta_5(3),
      DOA(2) => douta_5(2),
      DOA(1) => douta_5(1),
      DOA(0) => douta_5(0),
      DOB(31) => doutb_9(31),
      DOB(30) => doutb_9(30),
      DOB(29) => doutb_9(29),
      DOB(28) => doutb_9(28),
      DOB(27) => doutb_9(27),
      DOB(26) => doutb_9(26),
      DOB(25) => doutb_9(25),
      DOB(24) => doutb_9(24),
      DOB(23) => doutb_9(23),
      DOB(22) => doutb_9(22),
      DOB(21) => doutb_9(21),
      DOB(20) => doutb_9(20),
      DOB(19) => doutb_9(19),
      DOB(18) => doutb_9(18),
      DOB(17) => doutb_9(17),
      DOB(16) => doutb_9(16),
      DOB(15) => doutb_9(15),
      DOB(14) => doutb_9(14),
      DOB(13) => doutb_9(13),
      DOB(12) => doutb_9(12),
      DOB(11) => doutb_9(11),
      DOB(10) => doutb_9(10),
      DOB(9) => doutb_9(9),
      DOB(8) => doutb_9(8),
      DOB(7) => doutb_9(7),
      DOB(6) => doutb_9(6),
      DOB(5) => doutb_9(5),
      DOB(4) => doutb_9(4),
      DOB(3) => doutb_9(3),
      DOB(2) => doutb_9(2),
      DOB(1) => doutb_9(1),
      DOB(0) => doutb_9(0),
      DOPA(3) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_3_UNCONNECTED,
      DOPA(2) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_2_UNCONNECTED,
      DOPA(1) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_1_UNCONNECTED,
      DOPA(0) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPA_0_UNCONNECTED,
      DOPB(3) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_3_UNCONNECTED,
      DOPB(2) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_2_UNCONNECTED,
      DOPB(1) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_1_UNCONNECTED,
      DOPB(0) => NLW_BU2_U0_blk_mem_generator_valid_cstr_ramloop_0_ram_r_v4_ram_TRUE_DP_SINGLE_PRIM_TDP_DOPB_0_UNCONNECTED
    );
  BU2_XST_GND : GND
    port map (
      G => BU2_N0
    );

end STRUCTURE;

-- synopsys translate_on
